import cv2
import logging
import os
import time

logging.basicConfig(level=logging.DEBUG)

def get_frame():
    cap = cv2.VideoCapture(0)
    cap.set(cv2.CAP_PROP_BRIGHTNESS, 0)
    cap.set(cv2.CAP_PROP_CONTRAST, 0)
    
    start = time.perf_counter()
    while True:
        ret = cap.grab()
        _, frame = cap.retrieve(ret)
        if time.perf_counter() - start > 0.5:
            break
    
    frame = cv2.rotate(frame, cv2.cv2.ROTATE_90_CLOCKWISE)
    
    return frame

if __name__ == "__main__":
    try:
        os.mkdir("/tmp/out")
    except OSError:
        pass
    cv2.imwrite("/tmp/out/frame.png", get_frame())